diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.c nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.c
--- nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.c
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.c
@@ -43,17 +43,31 @@
 #include "nordic_common.h"
 #include <stddef.h>
 
+typedef enum {
+    BLE_DATA_BUF_FREE,
+    BLE_DATA_BUF_IN_USE,
+    BLE_DATA_BUF_LAST_DIRTY,
+} ble_data_buf_state_t;
+
 ser_ble_gap_conn_keyset_t m_conn_keys_table[SER_MAX_CONNECTIONS];
 #if NRF_SD_BLE_API_VERSION >= 6
 
 typedef struct
 {
+    ble_data_buf_state_t state;
     uint32_t id;
     uint8_t  ble_data[SER_MAX_ADV_DATA];
 } ble_data_item_t;
 
-ble_data_item_t m_ble_data_pool[8];
+typedef struct
+{
+    uint8_t * buf1;
+    uint8_t * buf2;
+} adv_set_data_t;
+
+static adv_set_data_t adv_set_data[BLE_GAP_ADV_SET_COUNT_MAX];
 
+ble_data_item_t m_ble_data_pool[8];
 static uint8_t * mp_scan_data;
 
 #endif
@@ -68,6 +82,7 @@ void conn_ble_gap_sec_keys_init(void)
 #if NRF_SD_BLE_API_VERSION >= 6
     for (i = 0; i < 8; i++)
     {
+        m_ble_data_pool[i].state = BLE_DATA_BUF_FREE;
         m_ble_data_pool[i].id = 0;
     }
 #endif
@@ -75,21 +90,21 @@ void conn_ble_gap_sec_keys_init(void)
 
 uint32_t conn_ble_gap_sec_context_create(uint32_t *p_index)
 {
-  uint32_t err_code = NRF_ERROR_NO_MEM;
-  uint32_t i;
+    uint32_t err_code = NRF_ERROR_NO_MEM;
+    uint32_t i;
 
-  for (i=0; i<SER_MAX_CONNECTIONS; i++ )
-  {
-    if ( ! m_conn_keys_table[i].conn_active )
+    for (i=0; i<SER_MAX_CONNECTIONS; i++)
     {
-        m_conn_keys_table[i].conn_active = 1;
-        *p_index = i;
-        err_code = NRF_SUCCESS;
-        break;
+        if (!m_conn_keys_table[i].conn_active)
+        {
+            m_conn_keys_table[i].conn_active = 1;
+            *p_index = i;
+            err_code = NRF_SUCCESS;
+            break;
+        }
     }
-  }
 
-  return err_code;
+    return err_code;
 }
 
 uint32_t conn_ble_gap_sec_context_destroy(uint16_t conn_handle)
@@ -117,7 +132,7 @@ uint32_t conn_ble_gap_sec_context_find(uint16_t conn_handle, uint32_t *p_index)
 
   for (i=0; i<SER_MAX_CONNECTIONS; i++ )
   {
-    if ( (m_conn_keys_table[i].conn_handle == conn_handle) && (m_conn_keys_table[i].conn_active == 1) )
+    if ((m_conn_keys_table[i].conn_handle == conn_handle) && (m_conn_keys_table[i].conn_active == 1))
     {
         *p_index = i;
         err_code = NRF_SUCCESS;
@@ -149,8 +164,9 @@ uint8_t * conn_ble_gap_ble_data_buf_alloc(uint32_t id)
 
     for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
     {
-        if (m_ble_data_pool[i].id == 0)
+        if (m_ble_data_pool[i].state == BLE_DATA_BUF_FREE)
         {
+            m_ble_data_pool[i].state = BLE_DATA_BUF_IN_USE;
             m_ble_data_pool[i].id = id;
             return m_ble_data_pool[i].ble_data;
         }
@@ -175,6 +191,7 @@ uint32_t conn_ble_gap_ble_data_buf_free(uint8_t * p_data)
         {
             uint32_t id = m_ble_data_pool[i].id;
             m_ble_data_pool[i].id = 0;
+            m_ble_data_pool[i].state = BLE_DATA_BUF_FREE;
             return id;
         }
     }
@@ -182,21 +199,66 @@ uint32_t conn_ble_gap_ble_data_buf_free(uint8_t * p_data)
     return 0;
 }
 
-void conn_ble_gap_scan_data_set(uint8_t * p_scan_data)
+void conn_ble_gap_ble_data_mark_dirty(uint8_t * p_data)
 {
-    mp_scan_data = p_scan_data;
+    uint32_t i;
+
+    if (p_data)
+    {
+        for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
+        {
+            if (m_ble_data_pool[i].ble_data == p_data)
+            {
+                m_ble_data_pool[i].state = BLE_DATA_BUF_LAST_DIRTY;
+            }
+        }
+    }
 }
 
-void conn_ble_gap_scan_data_unset(bool free)
+void conn_ble_gap_ble_adv_data_mark_dirty(uint8_t * p_data1, uint8_t *p_data2)
 {
-    if (mp_scan_data)
+    uint32_t i;
+
+    /* First find if given id already allocated the buffer. */
+    for (i = 0; i < ARRAY_SIZE(m_ble_data_pool); i++)
     {
-        if (free)
+        if (m_ble_data_pool[i].state == BLE_DATA_BUF_LAST_DIRTY)
         {
-            (void)conn_ble_gap_ble_data_buf_free(mp_scan_data);
+            conn_ble_gap_ble_data_buf_free(m_ble_data_pool[i].ble_data);
         }
-        mp_scan_data = NULL;
     }
+
+    conn_ble_gap_ble_data_mark_dirty(p_data1);
+    conn_ble_gap_ble_data_mark_dirty(p_data2);
+}
+
+void conn_ble_gap_scan_data_set(uint8_t * p_scan_data)
+{
+	mp_scan_data = p_scan_data;
+}
+
+void conn_ble_gap_scan_data_unset(bool free)
+{
+	if (mp_scan_data)
+	{
+		if (free)
+		{
+			conn_ble_gap_ble_data_buf_free(mp_scan_data);
+		}
+		mp_scan_data = NULL;
+	}
+}
+
+void conn_ble_gap_set_adv_data_set(uint8_t adv_handle, uint8_t * buf1, uint8_t * buf2)
+{
+    if (adv_handle == BLE_GAP_ADV_SET_HANDLE_NOT_SET)
+    {
+        adv_handle = BLE_GAP_ADV_SET_COUNT_MAX - 1;
+    }
+    conn_ble_gap_ble_adv_data_mark_dirty(adv_set_data[adv_handle].buf1, adv_set_data[adv_handle].buf2);
+
+    adv_set_data[adv_handle].buf1 = buf1;
+    adv_set_data[adv_handle].buf2 = buf2;
 }
 #endif
 
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.h nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/codecs/ble/serializers/conn_ble_gap_sec_keys.h
@@ -124,6 +124,8 @@ uint32_t conn_ble_gap_ble_data_buf_free(uint8_t * p_data);
 void conn_ble_gap_scan_data_set(uint8_t * p_scan_data);
 void conn_ble_gap_scan_data_unset(bool free);
 
+void conn_ble_gap_set_adv_data_set(uint8_t adv_handle, uint8_t * buf1, uint8_t * buf2);
+
 #ifdef __cplusplus
 }
 #endif
diff --git nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/ser_conn_handlers.h nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/ser_conn_handlers.h
--- nRF5_SDK_15.3.0_59ac345/components/serialization/connectivity/ser_conn_handlers.h
+++ nRF5_SDK_15.3.0_66869dd/components/serialization/connectivity/ser_conn_handlers.h
@@ -79,6 +79,8 @@ extern "C" {
 /** Maximum number of events in the application scheduler queue. */
 #ifdef S112
 #define SER_CONN_SCHED_QUEUE_SIZE             8u
+#elif defined(SER_PHY_HCI_USB_CDC)
+#define SER_CONN_SCHED_QUEUE_SIZE             64u
 #else
 #define SER_CONN_SCHED_QUEUE_SIZE             16u
 #endif
diff --git nRF5_SDK_15.3.0_59ac345/components/softdevice/common/nrf_sdh.c nRF5_SDK_15.3.0_66869dd/components/softdevice/common/nrf_sdh.c
--- nRF5_SDK_15.3.0_59ac345/components/softdevice/common/nrf_sdh.c
+++ nRF5_SDK_15.3.0_66869dd/components/softdevice/common/nrf_sdh.c
@@ -204,7 +204,11 @@ ret_code_t nrf_sdh_enable_request(void)
         .source       = NRF_SDH_CLOCK_LF_SRC,
         .rc_ctiv      = NRF_SDH_CLOCK_LF_RC_CTIV,
         .rc_temp_ctiv = NRF_SDH_CLOCK_LF_RC_TEMP_CTIV,
+#if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 3
         .accuracy     = NRF_SDH_CLOCK_LF_ACCURACY
+#else
+        .xtal_accuracy     = NRF_SDH_CLOCK_LF_ACCURACY
+#endif
     };
 
     CRITICAL_REGION_ENTER();
@@ -224,6 +228,13 @@ ret_code_t nrf_sdh_enable_request(void)
     m_nrf_sdh_continue  = false;
     m_nrf_sdh_suspended = false;
 
+#ifdef SOFTDEVICE_PRESENT
+    ret_code = sd_nvic_ClearPendingIRQ((IRQn_Type)SD_EVT_IRQn);
+    APP_ERROR_CHECK(ret_code);
+#else
+    // In case of serialization, NVIC must be accessed directly.
+    NVIC_ClearPendingIRQ((IRQn_Type)SD_EVT_IRQn);
+#endif
     // Enable event interrupt.
     // Interrupt priority has already been set by the stack.
     softdevices_evt_irq_enable();
diff --git nRF5_SDK_15.3.0_59ac345/components/softdevice/common/nrf_sdh_ble.c nRF5_SDK_15.3.0_66869dd/components/softdevice/common/nrf_sdh_ble.c
--- nRF5_SDK_15.3.0_59ac345/components/softdevice/common/nrf_sdh_ble.c
+++ nRF5_SDK_15.3.0_66869dd/components/softdevice/common/nrf_sdh_ble.c
@@ -102,8 +102,9 @@ ret_code_t nrf_sdh_ble_app_ram_start_get(uint32_t * p_app_ram_start)
 
 ret_code_t nrf_sdh_ble_default_cfg_set(uint8_t conn_cfg_tag, uint32_t * p_ram_start)
 {
-    uint32_t ret_code;
 
+#if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 3
+    uint32_t ret_code;
     ret_code = nrf_sdh_ble_app_ram_start_get(p_ram_start);
     if (ret_code != NRF_SUCCESS)
     {
@@ -197,7 +198,7 @@ ret_code_t nrf_sdh_ble_default_cfg_set(uint8_t conn_cfg_tag, uint32_t * p_ram_st
         NRF_LOG_ERROR("sd_ble_cfg_set() returned %s when attempting to set BLE_GATTS_CFG_SERVICE_CHANGED.",
                       nrf_strerror_get(ret_code));
     }
-
+#endif //defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 3
     return NRF_SUCCESS;
 }
 
@@ -217,7 +218,7 @@ static uint32_t ram_end_address_get(void)
     return RAM_START + ram_total_size;
 }
 
-
+#if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 4
 ret_code_t nrf_sdh_ble_enable(uint32_t * const p_app_ram_start)
 {
     // Start of RAM, obtained from linker symbol.
@@ -256,7 +257,46 @@ ret_code_t nrf_sdh_ble_enable(uint32_t * const p_app_ram_start)
 
     return ret_code;
 }
+#else
+ret_code_t nrf_sdh_ble_enable(ble_enable_params_t * p_ble_enable_params, uint32_t * const p_app_ram_start)
+{
+    // Start of RAM, obtained from linker symbol.
+    uint32_t const app_ram_start_link = *p_app_ram_start;
 
+    ret_code_t ret_code = sd_ble_enable(p_ble_enable_params, p_app_ram_start);
+    if (*p_app_ram_start > app_ram_start_link)
+    {
+        NRF_LOG_WARNING("Insufficient RAM allocated for the SoftDevice.");
+
+        NRF_LOG_WARNING("Change the RAM start location from 0x%x to 0x%x.",
+                        app_ram_start_link, *p_app_ram_start);
+        NRF_LOG_WARNING("Maximum RAM size for application is 0x%x.",
+                        ram_end_address_get() - (*p_app_ram_start));
+    }
+    else
+    {
+        NRF_LOG_DEBUG("RAM starts at 0x%x", app_ram_start_link);
+        if (*p_app_ram_start != app_ram_start_link)
+        {
+            NRF_LOG_DEBUG("RAM start location can be adjusted to 0x%x.", *p_app_ram_start);
+
+            NRF_LOG_DEBUG("RAM size for application can be adjusted to 0x%x.",
+                          ram_end_address_get() - (*p_app_ram_start));
+        }
+    }
+
+    if (ret_code == NRF_SUCCESS)
+    {
+        m_stack_is_enabled = true;
+    }
+    else
+    {
+        NRF_LOG_ERROR("sd_ble_enable() returned %s.", nrf_strerror_get(ret_code));
+    }
+
+    return ret_code;
+}
+#endif
 
 /**@brief       Function for polling BLE events.
  *
@@ -306,6 +346,12 @@ static void nrf_sdh_ble_evts_poll(void * p_context)
 
             handler(p_ble_evt, p_observer->p_context);
         }
+
+        /* Interrupt processing if sdh got suspended. */
+        if (nrf_sdh_is_suspended()) {
+	     ret_code = NRF_ERROR_NOT_FOUND;
+             break;
+        }
     }
 
     if (ret_code != NRF_ERROR_NOT_FOUND)
diff --git nRF5_SDK_15.3.0_59ac345/components/softdevice/common/nrf_sdh_ble.h nRF5_SDK_15.3.0_66869dd/components/softdevice/common/nrf_sdh_ble.h
--- nRF5_SDK_15.3.0_59ac345/components/softdevice/common/nrf_sdh_ble.h
+++ nRF5_SDK_15.3.0_66869dd/components/softdevice/common/nrf_sdh_ble.h
@@ -62,6 +62,12 @@
 extern "C" {
 #endif
 
+#ifndef BLE_EVT_LEN_MAX
+#define BLE_EVT_LEN_MAX(ATT_MTU) ( \
+    offsetof(ble_evt_t, evt.gattc_evt.params.prim_srvc_disc_rsp.services) + ((ATT_MTU) - 1) / 4 * sizeof(ble_gattc_service_t) \
+)
+
+#endif
 /** @brief  Size of the buffer for a BLE event. */
 #define NRF_SDH_BLE_EVT_BUF_SIZE BLE_EVT_LEN_MAX(NRF_SDH_BLE_GATT_MAX_MTU_SIZE)
 
@@ -172,8 +178,11 @@ ret_code_t nrf_sdh_ble_default_cfg_set(uint8_t conn_cfg_tag, uint32_t * p_ram_st
  *
  * @param[in]   p_app_ram_start     Address of the start of application's RAM.
  */
+#if defined(NRF_SD_BLE_API_VERSION) && NRF_SD_BLE_API_VERSION > 4
 ret_code_t nrf_sdh_ble_enable(uint32_t * p_app_ram_start);
-
+#else
+ret_code_t nrf_sdh_ble_enable(ble_enable_params_t * p_ble_enable_params, uint32_t * p_app_ram_start);
+#endif
 
 #ifdef __cplusplus
 }
